//-----------------------------------------
// LScript Generic Replace with Nulls
//
// Copyright 2006 Michael Green
// info@shortbutpurple.fsnet.co.uk
//

myversion=1.0;
@version 2.2
@warnings
@script generic
@name (Clone) Clone To Items
// global values go here

generic
{
    myprefix=recall("MGCloneToItemsPrefix","Null_");
    mysuffix=recall("MGCloneToItemsSuffix","_Null");
//    myoption=recall("MGReplacewithNullsOption",2);
    // perform all processing here

     reqbegin("MGClone To Items Ver:"+myversion);
// 
//     c0 = ctlinteger("Integer Control",1);
//     c1 = ctlnumber("Number Control",1.0);
     c1 = ctlstring("Prefix",myprefix);
     c2 = ctlstring("Suffix",mysuffix);
//     c3 = ctlchoice("Replace",myoption,@"Copy","Replace"@);
//
     return if !reqpost();

     // get requester control values here
    myprefix=getvalue(c1);
    mysuffix=getvalue(c2);
//    myoption=getvalue(c3);
    myoption=2;

    store("MGCloneToItemsPrefix",myprefix);
    store("MGCloneToItemsSuffix",mysuffix);
//    store("MGReplacewithNullsOption",myoption);

    reqend();

    myselected=Scene().getSelect();
    if(!myselected)
        error("Please select some items");
    CloneToItems(myselected,myprefix,mysuffix,myoption);
    SelectItemList(myselected);

}

CloneToItems:plist,pprefix,psuffix,replaceonly
{
    myidstring=globalrecall("MGLayoutCloneToItems",0);
    myid=myidstring.asInt();
    myitem=GetAgentByID(myid);
    if(!myitem)
        return;
//    debug();
    mytime=Scene().currenttime;

    mylinks=nil;

    for(i=1;i<=plist.size();i++)
    {
        myobj=plist[i];
        myname=pprefix+myobj.name+psuffix;
        SelectItem(myitem.id);
        Clone(1);
        Rename(myname);

        mypos=myobj.getWorldPosition(mytime);
        myrot=myobj.getWorldRotation(mytime);
        if(myobj.parent)
        {
            parentpos=CheckParent(myobj.parent,plist); // find parent pos in plist
            if(parentpos==0)      // add the parent to the list
            {
                plist[plist.size() + 1]=myobj.parent;
            }
        }
        Position(mypos);
        Rotation(myrot);
        Scale(myobj.getScaling(mytime));
        mynull=Scene().firstSelect();
        mylinks[i][1]=myobj;
        mylinks[i][2]=mynull;
   }

// reparent
//debug();
    if(!Scene().generalopts[3])
    {
        pip=1;
        ParentInPlace();
    }
    newparent=nil;
    for(i=1;i<=mylinks.size();i++)
    {
        myitem=mylinks[i][2];
        if(mylinks[i][1].parent)
        {

            oldparent=mylinks[i][1].parent;
            for(j=1;j<=mylinks.size();j++)
            {
                temp=mylinks[j][1];
                if(temp.id==oldparent.id)
                {
                    newparent=mylinks[j][2];
                    break;
                }
            }
            SelectItem(myitem.id);
            ParentItem(newparent.id);
        }
    }

    if(pip==1)
    {
        ParentInPlace();
    }

}

CheckParent:pparent,clist
{
    parentpos=0;
    for(i=1;i<=clist.size();i++)
    {
        if(pparent.id==clist[i].id)
        {
            parentpos=i;
            break;
        }
    }
    return(parentpos);
}

SelectItemList:plist
{
    if(!plist)
        return;
    SelectItem(plist[1].id);
    for(i=2;i<=plist.size();i++)
    {
        AddToSelection(plist[i].id);
    }
}

GetAgentByID:id
{
//debug();
    item=Mesh();
    while(item)
    {
        if (item.id==id)
            return item;
        tempbone=item.bone();
        while(tempbone)
        {
            if(tempbone.id==id)
                return tempbone;
            tempbone=tempbone.next();
        }
        item=item.next();
    }

    item=Light();
    while(item)
    {
        if (item.id==id)
            return item;
        item=item.next();
    }

    item=Camera();
    while(item)
    {
        if (item.id==id)
            return item;
        item=item.next();
    }
    return (nil);
    
}

